//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@̂݃VF[_ for ʃhbvVhEGtFNg v0.2
//@@@by iuser/5145841j
//
//@@@̃GtFNg͐jo EdgeControl ̂ł
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

//=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
//@[U[p[^@

//@hbvVhÊ̑ݒ̊
float ThicknessRate = 1.0;

//@GbW`悷ގԍilFׂ "0-"j
#define EDGE_ON "0-"

//@[U[p[^@܂
//@̓GtFNgɏڂ
//=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=


//=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
//@`
#define fmRange 0.8f	// fL`悷邱Ƃŉʉ̕sy

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@eϐ`

float DotsScale : CONTROLOBJECT < string name = "o_DotsDropShdw.x"; string item = "Si"; >;
static float EdgeThickness = ThicknessRate * (DotsScale + 5.0);

//@Wϊs
float4x4 WorldMatrix    : WORLD;
float4x4 ViewMatrix     : VIEW;
float4x4 ProjMatrix     : PROJECTION;
float4x4 ViewProjMatrix : VIEWPROJECTION;

float3 CameraPosition   : POSITION  < string Object = "Camera"; >;

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
#ifndef MIKUMIKUMOVING
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);
#endif

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state
{
	texture = <ObjectTexture>;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
};

bool use_texture;  //eNX`̗L
bool use_toon;     //gD[̗L

//=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
//@f𑾂点ĕ`悷
struct VS_OUTPUT
{
	float4 Pos		: POSITION;		// ˉeϊW
	float3 Normal	: COLOR0;		// @
	float2 TexCoord	: TEXCOORD0;	// UV
};

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@_VF[_
#ifndef MIKUMIKUMOVING
VS_OUTPUT VS_Draw(float4 Pos: POSITION, float3 Normal: NORMAL, float2 Tex: TEXCOORD0)
#else
VS_OUTPUT VS_Draw(MMM_SKINNING_INPUT IN)
#endif
{
	VS_OUTPUT Out = (VS_OUTPUT)0;

	//MikuMikuMovingƎ̃XLjO֐(MMM_SkinnedPositionNormal)B
	#ifdef MIKUMIKUMOVING
	MMM_SKINNING_OUTPUT SkinOut = MMM_SkinnedPositionNormal(IN.Pos, IN.Normal, IN.BlendWeight, IN.BlendIndices, IN.SdefC, IN.SdefR0, IN.SdefR1);

	float4 Pos = SkinOut.Position;
	float3 Normal = SkinOut.Normal;
	float2 Tex = IN.Tex;
	#endif

	//@[hWϊ
    Out.Pos = mul(Pos, WorldMatrix);
    Out.Normal = normalize(mul(Normal, (float3x3)WorldMatrix));

    // JƂ̋
    float len = max(length(CameraPosition - Out.Pos), 5.0);

    // _@ɉo
    Out.Pos.xyz += Out.Normal * (len * EdgeThickness * 0.0015 * pow(2.4142 / ProjMatrix._11, 0.7));

    // J_̃r[ˉeϊ
	ProjMatrix._11 *= fmRange;
	ProjMatrix._22 *= fmRange;

	Out.Pos = mul(Out.Pos, mul(ViewMatrix, ProjMatrix));

	Out.TexCoord = Tex;

    return Out;
}

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@sNZVF[_ieNX`ގpj
float4 PS_Draw(VS_OUTPUT IN) : COLOR
{
    return float4(1.0, 1.0, 1.0, 1.0);
}

//@sNZVF[_(eNX`Lގp)
float4 PS_DrawTex(VS_OUTPUT IN) : COLOR
{
    return float4(1.0, 1.0, 1.0, tex2D(ObjTexSampler, IN.TexCoord).a);
}

//=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
// ֊s`peNjbN
technique MainTec < string MMDPass = "object"; bool UseTexture = false; > {
    pass DrawObject {
        CullMode = None;

    	VertexShader = compile vs_2_0 VS_Draw();
        PixelShader  = compile ps_2_0 PS_Draw();
    }
}

technique MainTecBS < string MMDPass = "object_ss"; bool UseTexture = false; > {
    pass DrawObject {
        CullMode = None;

    	VertexShader = compile vs_2_0 VS_Draw();
        PixelShader  = compile ps_2_0 PS_Draw();
    }
}

technique MainTexTec < string MMDPass = "object"; bool UseTexture = true; > {
    pass DrawObject {
        CullMode = None;
        AlphaBlendEnable = true;
        AlphaTestEnable  = false;

    	VertexShader = compile vs_2_0 VS_Draw();
        PixelShader  = compile ps_2_0 PS_DrawTex();
    }
}

technique MainTexTecBS < string MMDPass = "object_ss"; bool UseTexture = true; > {
    pass DrawObject {
        CullMode = None;
        AlphaBlendEnable = true;
        AlphaTestEnable  = false;

    	VertexShader = compile vs_2_0 VS_Draw();
        PixelShader  = compile ps_2_0 PS_DrawTex();
    }
}

technique EdgeTec < string MMDPass = "edge"; > {
}

technique ShadowTec < string MMDPass = "shadow"; > {
}
//=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=+=
